package com.jkcredit.utils;

import com.jkcredit.config.BaseResult;

/**
 * @description:
 * @author: sunzhaoning
 * @create: 2019-05-14 11:59
 * @version: V1.0
 **/

public class ResultUtil {

    public static <T> BaseResult<T> success(T data,String transactionId) {
        return commonResult( 1000, "请求成功", data,transactionId);
    }

    public static <T> BaseResult<T> error(String errorMsg) {
        return error(200, errorMsg,null);
    }

    public static <T> BaseResult<T> error(Integer code, String errorMsg) {
        return commonResult( code, errorMsg, null,null);
    }

    public static <T> BaseResult<T> error(Integer code, String errorMsg,String transactionId) {
        return commonResult( code, errorMsg, null,transactionId);
    }

    private static <T> BaseResult<T> commonResult( Integer code, String errMsg, T data,String transactionId) {
        BaseResult<T> result = new BaseResult<>();
//        result.setStatus(status);
        result.setCode(code);
        result.setMsg(errMsg);
        result.setData(data);
        result.setTransactionId(transactionId);
        return result;
    }
}
